/*!\file
 * \author Matthias Elf
 *
 * \par License:
 * This file is part of ABACUS - A Branch And CUt System
 * Copyright (C) 1995 - 2003                                                  
 * University of Cologne, Germany                                             
 * 
 * \par                                                                           
 * This library is free software; you can redistribute it and/or              
 * modify it under the terms of the GNU Lesser General Public                 
 * License as published by the Free Software Foundation; either               
 * version 2.1 of the License, or (at your option) any later version.         
 *     
 * \par                                                                       
 * This library is distributed in the hope that it will be useful,            
 * but WITHOUT ANY WARRANTY; without even the implied warranty of             
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU          
 * Lesser General Public License for more details.                            
 *     
 * \par                                                                       
 * You should have received a copy of the GNU Lesser General Public           
 * License along with this library; if not, write to the Free Software        
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA  
 *
 * \see http://www.gnu.org/copyleft/gpl.html
 */

#ifndef ABA_DICTIONARY_INC
#define ABA_DICTIONARY_INC

  template <class KeyType, class ItemType>
  ABA_DICTIONARY<KeyType, ItemType>::ABA_DICTIONARY(ABA_GLOBAL *glob, int size)
  :  
    glob_(glob),
    hash_(glob, size)
  { }

  template <class KeyType, class ItemType>
  ostream &operator<<(ostream &out, const ABA_DICTIONARY<KeyType, ItemType> &rhs)
  {
    return out << rhs.hash_;
  }

  template <class KeyType, class ItemType>
  inline void ABA_DICTIONARY<KeyType, ItemType>::insert(const KeyType &key, 
                                                 const ItemType &item)
  {
    hash_.insert(key, item);
  }

  template <class KeyType, class ItemType>
  inline ItemType* ABA_DICTIONARY<KeyType, ItemType>::lookUp(const KeyType &key)
  {
    return hash_.find(key);
  }

#endif   // ABA_DICTIONARY_INC
